Index: main/waeup.kofa/trunk/CHANGES.txt
===================================================================
--- main/waeup.kofa/trunk/CHANGES.txt	(revision 15584)
+++ main/waeup.kofa/trunk/CHANGES.txt	(revision 15587)
@@ -4,4 +4,7 @@
 1.6.1.dev0 (unreleased)
 =======================
+
+* Do not print picture on application slip if application is without
+  passport picture.
 
 * Do not copy applicant_id into reg_number field after applicant creation.
Index: main/waeup.kofa/trunk/src/waeup/kofa/applicants/pdf.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/applicants/pdf.py	(revision 15584)
+++ main/waeup.kofa/trunk/src/waeup/kofa/applicants/pdf.py	(revision 15587)
@@ -140,31 +140,41 @@
         data.append(Spacer(1, 5))
 
-        # create three-column header table
-        # append photograph to the left
-        img_path = getattr(
-            getUtility(IExtFileStore).getFileByContext(self.context),
-            'name', DEFAULT_PASSPORT_IMAGE_PATH)
-        data_left = [[creator.getImage(img_path)]]
-        table_left = Table(data_left,style=SLIP_STYLE)
-
-        # append base data table to the middle
-        fields = [
-            field for field in self.form_fields
-                if field.__name__ in self.column_two_fields]
-        table_middle = creator.getWidgetsTable(
-            fields, self.context, None, lang=portal_language,
-            separators=None, colWidths=[5*cm, 4.5*cm])
-
-        # append QR code to the right
-        if view is not None:
-            url = view.url(self.context, 'application_slip.pdf')
-            data_right = [[get_qrcode(url, width=70.0)]]
-            table_right = Table(data_right,style=SLIP_STYLE)
+        if self.context.__parent__.with_picture:
+
+            # create three-column header table
+            # append photograph to the left
+            img_path = getattr(
+                getUtility(IExtFileStore).getFileByContext(self.context),
+                'name', DEFAULT_PASSPORT_IMAGE_PATH)
+            data_left = [[creator.getImage(img_path)]]
+            table_left = Table(data_left,style=SLIP_STYLE)
+
+            # append base data table to the middle
+            fields = [
+                field for field in self.form_fields
+                    if field.__name__ in self.column_two_fields]
+            table_middle = creator.getWidgetsTable(
+                fields, self.context, None, lang=portal_language,
+                separators=None, colWidths=[5*cm, 4.5*cm])
+
+            # append QR code to the right
+            if view is not None:
+                url = view.url(self.context, 'application_slip.pdf')
+                data_right = [[get_qrcode(url, width=70.0)]]
+                table_right = Table(data_right,style=SLIP_STYLE)
+            else:
+                table_right = None
+
+            header_table = Table(
+                [[table_left, table_middle, table_right],],style=SLIP_STYLE)
+            data.append(header_table)
+
         else:
-            table_right = None
-
-        header_table = Table(
-            [[table_left, table_middle, table_right],],style=SLIP_STYLE)
-        data.append(header_table)
+            fields = [
+                field for field in self.form_fields
+                    if field.__name__ in self.column_two_fields]
+            data.append(creator.getWidgetsTable(
+                fields, self.context, None, lang=portal_language,
+                separators=None, colWidths=[7*cm, 10*cm]))
 
         # append widgets except those already added in column two
@@ -195,4 +205,12 @@
                     twoDataCols=True))
 
+        # append QR Code if without picture
+        if not self.context.__parent__.with_picture and view is not None:
+            data.append(Spacer(1, 5))
+            url = view.url(self.context, 'application_slip.pdf')
+            data_right = [[get_qrcode(url, width=70.0)]]
+            table_right = Table(data_right,style=SLIP_STYLE)
+            data.append(get_qrcode(url, width=70.0))
+
         # append login information
         note = None