Index: main/waeup.fceokene/trunk/src/waeup/fceokene/students/tests/test_browser.py
===================================================================
--- main/waeup.fceokene/trunk/src/waeup/fceokene/students/tests/test_browser.py	(revision 15523)
+++ main/waeup.fceokene/trunk/src/waeup/fceokene/students/tests/test_browser.py	(revision 15594)
@@ -229,5 +229,5 @@
         self.assertEqual(payment.p_level, 100)
         self.assertEqual(payment.p_session, 2004)
-        self.assertEqual(payment.amount_auth, 70457.5)
+        self.assertEqual(payment.amount_auth, 70000)
         self.assertEqual(payment.p_item, u'CERT1')
         self.assertEqual(error, None)
@@ -242,5 +242,5 @@
         self.assertEqual(payment.p_level, 200)
         self.assertEqual(payment.p_session, 2005)
-        self.assertEqual(payment.amount_auth, 35457.5)
+        self.assertEqual(payment.amount_auth, 35300)
         self.assertEqual(payment.p_item, u'CERT1')
         self.assertEqual(error, None)
@@ -249,10 +249,10 @@
         self.certificate.study_mode = 'ug_ft'
         error, payment = utils.setPaymentDetails('schoolfee',self.student)
-        self.assertEqual(payment.amount_auth,  56307.5)
+        self.assertEqual(payment.amount_auth,  56150)
         self.assertEqual(error, None)
         # UG cleared students pay 65650
         IWorkflowState(self.student).setState('cleared')
         error, payment = utils.setPaymentDetails('schoolfee',self.student)
-        self.assertEqual(payment.amount_auth, 65807.5)
+        self.assertEqual(payment.amount_auth, 65650)
         self.assertEqual(error, None)
 
@@ -272,5 +272,5 @@
         self.assertEqual(payment.p_level, 100)
         self.assertEqual(payment.p_session, 2004)
-        self.assertEqual(payment.amount_auth, 277.5)
+        self.assertEqual(payment.amount_auth, 120)
         self.assertEqual(payment.p_item, u'CERT1')
         self.assertEqual(error, None)
@@ -285,5 +285,5 @@
         self.assertEqual(payment.p_level, 100)
         self.assertEqual(payment.p_session, 2004)
-        self.assertEqual(payment.amount_auth, 1033.5)
+        self.assertEqual(payment.amount_auth, 876)
         self.assertEqual(payment.p_item, u'My bed coordinates')
         self.assertEqual(error, None)
@@ -292,5 +292,5 @@
         self.assertEqual(payment.p_level, 100)
         self.assertEqual(payment.p_session, 2004)
-        self.assertEqual(payment.amount_auth, 8095.5)
+        self.assertEqual(payment.amount_auth, 7938)
         self.assertEqual(payment.p_item, u'')
         self.assertEqual(error, None)
@@ -300,5 +300,5 @@
         self.assertEqual(payment.p_level, 100)
         self.assertEqual(payment.p_session, 2004)
-        self.assertEqual(payment.amount_auth, 705.0)  # 62.5% * 876 + 157.5
+        self.assertEqual(payment.amount_auth, 547.5)  # 62.5% * 876
         self.assertEqual(payment.p_item, u'My bed coordinates')
         self.assertEqual(error, None)
@@ -307,5 +307,5 @@
         self.assertEqual(payment.p_level, 100)
         self.assertEqual(payment.p_session, 2004)
-        self.assertEqual(payment.amount_auth, 307.5)
+        self.assertEqual(payment.amount_auth, 150)
         self.assertEqual(payment.p_item, u'')
         self.assertEqual(error, None)
Index: main/waeup.fceokene/trunk/src/waeup/fceokene/students/tests/test_utils.py
===================================================================
--- main/waeup.fceokene/trunk/src/waeup/fceokene/students/tests/test_utils.py	(revision 15523)
+++ main/waeup.fceokene/trunk/src/waeup/fceokene/students/tests/test_utils.py	(revision 15594)
@@ -84,7 +84,7 @@
         IWorkflowState(self.student).setState('returning')
         error, payment = utils.setPaymentDetails('schoolfee',self.student)
-        self.assertEqual(payment.amount_auth, 16131.5) # 15875 + 157.5 + 99
+        self.assertEqual(payment.amount_auth, 15974) # 15875 + 99
         self.student['studycourse'].previous_verdict = 'O'
         error, payment = utils.setPaymentDetails('schoolfee',self.student)
-        self.assertEqual(payment.amount_auth, 16032.5) # 15875 + 157.5
+        self.assertEqual(payment.amount_auth, 15875)
         return
Index: main/waeup.fceokene/trunk/src/waeup/fceokene/students/utils.py
===================================================================
--- main/waeup.fceokene/trunk/src/waeup/fceokene/students/utils.py	(revision 15523)
+++ main/waeup.fceokene/trunk/src/waeup/fceokene/students/utils.py	(revision 15594)
@@ -38,5 +38,5 @@
         'NFRE','NARB','NHAU','NIGB','NYOR','NSOS')
 
-GATEWAY_AMT = 157.50
+GATEWAY_AMT = 0.0
 
 class CustomStudentsUtils(NigeriaStudentsUtils):